unit Yrnagfrm;

interface

uses
	WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, SysUtils, Gauges;

type
  TFormNag = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    ProgramIcon: TImage;
    GangScreen: TMemo;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments1: TLabel;
    WinVersion: TLabel;
    DosVersion: TLabel;
    Coprocessor: TLabel;
    CPU: TLabel;
    SystemGauge: TGauge;
    UserGauge: TGauge;
    GDIGauge: TGauge;
    FreeMemory: TLabel;
    FreeDisk: TLabel;
    NbTasks: TLabel;
    Ok_Btn: TBitBtn;
    TheTime: TPanel;
    Timer1: TTimer;
    Licence: TMemo;
    Comments2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
		procedure SetDetails(Const PName,Ver,Copy,Comment1,Comment2 : String);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      										Shift: TShiftState);
    procedure GangScreenClick(Sender: TObject);
    procedure ProgramIconClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SetData(Sender: TObject);
  private
    fileHandle	: THandle;
    fileBuffer	: Array [0..29] of Char;
    wVersion		: Word;
    dVersion		: Word;
    winFlags		: LongInt;
    driveCh			: Array [0..1] of Char ;
    driveS			: String[1] ;
		TimeIndex, TotTime : Byte;
  public
    { Public declarations }
    MaxTime : Byte ;
  end;

var
  FormNag : TFormNag;

implementation

{$R *.DFM}

procedure TFormNag.FormCreate(Sender: TObject);
begin
	KeyPreview	:= True ;
end;

procedure TFormNag.FormActivate(Sender: TObject);
begin
  { Recherche des version de DOS & WINDOWS }
  wVersion := LoWord(GetVersion);
  dVersion := HiWord(GetVersion);
  WinVersion.Caption := IntToStr(LO(wVersion)) + '.' + IntToStr(HI(wVersion)) ;
  DosVersion.Caption := IntToStr(HI(dVersion)) + '.' + IntToStr(LO(dVersion));

  { Information sur WINDOWS et la configuration du PC }
  winFlags := GetWinFlags;
  { 1) Dtermine le mode de WINDOWS }
	If (GetWinFlags and wf_Enhanced) <> 0
		then	WinVersion.Caption := WinVersion.Caption + ' in Enhanced Mode'
		else	WinVersion.Caption := WinVersion.Caption + ' in Standard Mode' ;
	{ 2) Utilisation d'un coprocesseur }
  If winFlags and WF_80x87 > 0
  	then	Coprocessor.Caption := 'Present'
  	else	Coprocessor.Caption := 'Not Present';
  { 3) Dtermine le type de PROCESSEUR }
	If winFlags and WF_CPU486 > 0
  	then	CPU.Caption := '486 or Pentium';
  If winFlags and WF_CPU386 > 0
  	then	CPU.Caption := '386';
  If winFlags and WF_CPU286 > 0
  	then	CPU.Caption := '286';

  { Dtermine le pourcentage de mmoire RESOURCES libre }
	SystemGauge.Progress  := GetFreeSystemResources(GFSR_SystemResources);
  { Dtermine le pourcentage de mmoire GDI libre }
	GDIGauge.Progress     := GetFreeSystemResources(GFSR_GDIResources);
  { Dtermine le pourcentage de mmoire USER libre }
	UserGauge.Progress    := GetFreeSystemResources(GFSR_UserResources);

  {{ Dtermine la mmoire libre dans le Heap global }
	FreeMemory.Caption   := IntToStr(GetFreeSpace(0) DIV 1024) + ' KB' ;
  { Dtermine la place libre sur le disque qui contient cette application }
	driveS	:= UpperCase(ExtractFilePath(Application.ExeName)[1]) ;
  StrPCopy(driveCh,driveS) ;
  FreeDisk.Caption := IntToStr(DiskFree(ord(driveCh[0])-64) div 1024) + ' KB';
	{ Dtermine le plus grand bloc de mmoire libre dans le Heap global }
	{LargeMemSize.Caption  := IntToStr(GlobalCompact(0) DIV 1024) + ' Ko' ;}
	{ Calcul du nombre de processus actifs }
  NbTasks.Caption := IntToStr(GetNumTasks) ;

  { Recherche du nom de l'utilisateur et de son entreprise }
  {
  try
  	fileHandle := LoadLibrary('USER');
  	If fileHandle >= HINSTANCE_ERROR then
  	begin
    	If LoadString(fileHandle, 514, fileBuffer, 30) <> 0
    		then	UserName.Caption := fileBuffer;
	    If LoadString(fileHandle, 515, fileBuffer, 30) <> 0
  	  	then	CompanyName.Caption := fileBuffer;
  	end ;
  finally
    FreeLibrary(fileHandle);
  end;
  }
end;

procedure TFormNag.SetDetails(Const PName,Ver,Copy,Comment1,Comment2 : String);
begin
  ProductName.Caption	:= PName ;
	Version.Caption 		:= Ver ;
  Copyright.Caption		:= Copy ;
  Comments1.Caption		:= Comment1 ;
  Comments2.Caption		:= Comment2 ;
end;

procedure TFormNag.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  GangScreen.Visible := False ;
  If ((Shift = []) and (Key = vk_Return))	then
  	Begin
  		Button1Click(Sender) ;
    End	else
  If ((Shift = [ssAlt]) and (Key = vk_Space)) and not GangScreen.Visible then
  Begin
    {MessageDlg('Alt+SPACE pressed down', mtInformation, [mbOK], 0);}
    GangScreen.Visible  := True ;
  End ;
  Key := 0 ;
end;

procedure TFormNag.GangScreenClick(Sender: TObject);
begin
  GangScreen.Visible := False ;
end;

procedure TFormNag.ProgramIconClick(Sender: TObject);
begin
  GangScreen.Visible := True ;
end;

procedure TFormNag.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TFormNag.Timer1Timer(Sender: TObject);
begin
  Dec(TotTime);
  Inc(TimeIndex);
  TheTime.Caption := IntToStr(TotTime);
  if TimeIndex >= MaxTime then
  begin
    OK_Btn.Visible 	:= True;
    TheTime.Visible := False;
    Timer1.Enabled 	:= False;
  end;
end;

procedure TFormNag.SetData(Sender: TObject);
begin
  TimeIndex := 0;
  TotTime		:= MaxTime;
  If MaxTime > 0 then
  begin
    TheTime.Visible := True;
    TheTime.Caption := IntToStr(MaxTime);
    Timer1.Enabled 	:= True;
  end else
  begin
    TheTime.Visible	:= False;
    OK_Btn.Visible 	:= True;
  end;
end;

end.

